#pragma once
#include "LittleFS.h"
#define TOKENBUFFERCAPACITY 3
#define TOKENLENGHT 10
namespace webconsole
{

    struct TokenBuffer
    {

        TokenBuffer()
        {
            for (uint16_t j = 0; j < TOKENBUFFERCAPACITY; j++)
                setnull(j);
        }
        char *newToken()
        {
            if (next >= TOKENBUFFERCAPACITY)
                next = 0;
            for (uint16_t i = 0; i < TOKENLENGHT; i++)
                token[next][i] = randomChar();
            token[next][TOKENLENGHT] = 0x00;

            return &token[next++][0];
        }
        int16_t exists(const char *cmp)
        {
            for (uint16_t j = 0; j < TOKENBUFFERCAPACITY; j++)
            {
                bool match = true;
                for (uint16_t i = 0; match && i < TOKENLENGHT; i++)
                    if (token[j][i] != cmp[i])
                        match = false;
                if (match)
                    return j;
            }
            return -1;
        }
        void setnull(uint16_t index)
        {
            if (index >= 0 && index < TOKENBUFFERCAPACITY)
                for (uint16_t i = 0; i < TOKENLENGHT; i++)
                    token[index][i] = 0x00; // initialize with nullbytes
        }

    private:
        uint16_t next = 0;
        char token[TOKENBUFFERCAPACITY][TOKENLENGHT + 1];
        char randomChar()
        {
            auto charrype = random(0, 3);
            switch (charrype)
            {
            case 0:
                return random(0x30, 0x3A); // Numbers
                break;
            case 1:
                return random(0x41, 0x5B); // Capital Letters
                break;
            case 2:
                return random(0x61, 0x7B); // Small Letters
                break;
            }
            return 0x21;
        }
    };
    class AdminAuth
    {
    public:
        char *login(const char *username, const char *password);
        bool isAuth(const char *token);
        bool logout(const char *token);

    private:
        TokenBuffer *tokenbuffer = new TokenBuffer();
    };
}